/* Tabela RECEFILI: Receita Local */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela RECEFILI */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Receita Local,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_RECEFILI
AFTER DELETE OR INSERT OR UPDATE
ON RECEFILI FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_CDARVPROD VARCHAR2(20);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDARVPROD := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
      V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL;
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      IF (NVL(:OLD.CDAPRERECE, '') <> '') THEN
         V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE;
      END IF;
      V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODRECLOC, 5), '9999999990.00000'));
      IF (NVL(:OLD.SGUNIDADE, '') <> '') THEN
         V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE;
      END IF;
      IF (NVL(:OLD.VRPEFATCOCLO, -1) <> -1) THEN
         V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCLO, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.VRPEFATCORLO, -1) <> -1) THEN
         V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORLO, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.HRTEMPPREPLO, '') <> '') THEN
         V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPLO, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPLO, 4, 5);
      END IF;
      IF (NVL(:OLD.QTBRUTALOUNR, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTALOUNR, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTBRUTALO, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTALO, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.IDPRODBASELO, '') <> '') THEN
         V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASELO;
      END IF;
      IF (NVL(:OLD.VRPEFATNUTLO, -1) <> -1) THEN
         V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTLO, 5), '9999999990.00'));
      END IF;
      IF (NVL(:OLD.QTCALCNUTRLO, -1) <> -1) THEN
         V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRLO, 5), '9999999990.00000'));
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||:OLD.CDFILIAL||V_CDARVPROD;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDPRATO      <> :NEW.CDPRATO     ) OR
            (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) OR
            (:OLD.CDFILIAL     <> :NEW.CDFILIAL    ) OR
            (:OLD.CDPRODUTO    <> :NEW.CDPRODUTO   ) OR
            (:OLD.QTPRODRECLOC <> :NEW.QTPRODRECLOC) OR
            (NVL(:OLD.CDAPRERECE,   '') <> NVL(:NEW.CDAPRERECE,   '')) OR
            (NVL(:OLD.SGUNIDADE,    '') <> NVL(:NEW.SGUNIDADE,    '')) OR
            (NVL(:OLD.HRTEMPPREPLO, '') <> NVL(:NEW.HRTEMPPREPLO, '')) OR
            (NVL(:OLD.IDPRODBASELO, '') <> NVL(:NEW.IDPRODBASELO, '')) OR
            (NVL(:OLD.VRPEFATCOCLO,  -1) <> NVL(:NEW.VRPEFATCOCLO,  -1)) OR
            (NVL(:OLD.VRPEFATCORLO,  -1) <> NVL(:NEW.VRPEFATCORLO,  -1)) OR
            (NVL(:OLD.QTBRUTALOUNR,  -1) <> NVL(:NEW.QTBRUTALOUNR,  -1)) OR
            (NVL(:OLD.QTBRUTALO,     -1) <> NVL(:NEW.QTBRUTALO,     -1)) OR
            (NVL(:OLD.VRPEFATNUTLO,  -1) <> NVL(:NEW.VRPEFATNUTLO,  -1)) OR
            (NVL(:OLD.QTCALCNUTRLO,  -1) <> NVL(:NEW.QTCALCNUTRLO,  -1)) THEN
            V_TIPO   := '2';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_ITPESQ := :OLD.CDPRATO||:OLD.CDFILAUXPRAT||:OLD.CDFILIAL||V_CDARVPROD;
         END IF;
      ELSE
         V_TIPO   := '1';
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_ITPESQ := :NEW.CDPRATO||:NEW.CDFILAUXPRAT||:NEW.CDFILIAL||V_CDARVPROD;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRATO <> :NEW.CDPRATO) OR (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
            IF (:OLD.CDPRATO <> :NEW.CDPRATO) THEN
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || '|' || :NEW.CDPRATO || ' - ';
            ELSE
               V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ';
            END IF;
            IF (:OLD.CDFILAUXPRAT <> :NEW.CDFILAUXPRAT) THEN
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT || '|' || :NEW.CDFILAUXPRAT;
            ELSE
               V_DESC := V_DESC || :OLD.CDFILAUXPRAT;
            END IF; 
         ELSE
            V_DESC := V_DESC || 'Prato=' || :OLD.CDPRATO || ' - ' || :OLD.CDFILAUXPRAT;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Prato=' || :NEW.CDPRATO || ' - ' || :NEW.CDFILAUXPRAT;
      END IF; 
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || ' Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Fili=' || :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRODUTO <> :NEW.CDPRODUTO) THEN
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
            V_DESC := V_DESC || '|' || V_CDARVPROD;
         ELSE
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
         END IF;
      ELSE
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF (NVL(:NEW.CDAPRERECE, '') <> '') OR (UPDATING AND (NVL(:NEW.CDAPRERECE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDAPRERECE, '') <> NVL(:NEW.CDAPRERECE, '')) THEN
               V_DESC := V_DESC || ' Apres=' || :OLD.CDAPRERECE || '|' || :NEW.CDAPRERECE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Apres=' || :NEW.CDAPRERECE;
         END IF;
      END IF;
      IF UPDATING THEN
         IF (:OLD.QTPRODRECLOC <> :NEW.QTPRODRECLOC) THEN
            V_DESC := V_DESC || ' Qtde.=' || TRIM(TO_CHAR(ROUND(:OLD.QTPRODRECLOC, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODRECLOC, 5), '9999999990.00000'));
         END IF;
      ELSE
         V_DESC := V_DESC || ' Qtde=' || TRIM(TO_CHAR(ROUND(:NEW.QTPRODRECLOC, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:NEW.SGUNIDADE, '') <> '') OR (UPDATING AND (NVL(:NEW.SGUNIDADE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.SGUNIDADE, '') <> NVL(:NEW.SGUNIDADE, '')) THEN
               V_DESC := V_DESC || ' Un=' || :OLD.SGUNIDADE || '|' || :NEW.SGUNIDADE;
            END IF;
         ELSE 
            V_DESC := V_DESC || ' Un=' || :NEW.SGUNIDADE;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCOCLO, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCOCLO, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATCOCLO, -1) <> NVL(:NEW.VRPEFATCOCLO, -1)) THEN
               V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCOCLO, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCLO, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' GanhoCoc=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCOCLO, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATCORLO, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATCORLO, -1) = -1)) THEN
         IF UPDATING THEN
             IF (NVL(:OLD.VRPEFATCORLO, -1) <> NVL(:NEW.VRPEFATCORLO, -1)) THEN  
                V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATCORLO, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORLO, 5), '9999999990.00'));
             END IF;
         ELSE
            V_DESC := V_DESC || ' PerdLimp=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATCORLO, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.HRTEMPPREPLO, '') <> '') OR (UPDATING AND (NVL(:NEW.HRTEMPPREPLO, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.HRTEMPPREPLO, '') <> NVL(:NEW.HRTEMPPREPLO, '')) THEN  
               IF (NVL(:OLD.HRTEMPPREPLO, '') = '') THEN
                  V_DESC := V_DESC || ' Temp=' || '|' || SUBSTR(:NEW.HRTEMPPREPLO, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPLO, 4, 5); 
               ELSE
                  V_DESC := V_DESC || ' Temp=' || SUBSTR(:OLD.HRTEMPPREPLO, 1, 3) || ':' || SUBSTR(:OLD.HRTEMPPREPLO, 4, 5) || '|' || SUBSTR(:NEW.HRTEMPPREPLO, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPLO, 4, 5);
               END IF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Temp=' || SUBSTR(:NEW.HRTEMPPREPLO, 1, 3) || ':' || SUBSTR(:NEW.HRTEMPPREPLO, 4, 5);
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTALOUNR, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTALOUNR, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTALOUNR, -1) <> NVL(:NEW.QTBRUTALOUNR, -1)) THEN  
               V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTALOUNR, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTALOUNR, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtBruta=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTALOUNR, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTBRUTALO, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTBRUTALO, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTBRUTALO, -1) <> NVL(:NEW.QTBRUTALO, -1)) THEN  
               V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:OLD.QTBRUTALO, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTALO, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtReq=' || TRIM(TO_CHAR(ROUND(:NEW.QTBRUTALO, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.IDPRODBASELO, '') <> '') OR (UPDATING AND (NVL(:NEW.IDPRODBASELO, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDPRODBASELO, '') <> NVL(:NEW.IDPRODBASELO, '')) THEN  
               V_DESC := V_DESC || ' PrBase=' || :OLD.IDPRODBASELO || '|' || :NEW.IDPRODBASELO;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PrBase=' || :NEW.IDPRODBASELO;
         END IF;
      END IF;
      IF (NVL(:NEW.VRPEFATNUTLO, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRPEFATNUTLO, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRPEFATNUTLO, -1) <> NVL(:NEW.VRPEFATNUTLO, -1)) THEN  
               V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:OLD.VRPEFATNUTLO, 5), '9999999990.00')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTLO, 5), '9999999990.00'));
            END IF; 
         ELSE
            V_DESC := V_DESC || ' AprovNutr=' || TRIM(TO_CHAR(ROUND(:NEW.VRPEFATNUTLO, 5), '9999999990.00'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTCALCNUTRLO, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTCALCNUTRLO, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.QTCALCNUTRLO, -1) <> NVL(:NEW.QTCALCNUTRLO, -1)) THEN
               V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:OLD.QTCALCNUTRLO, 5), '9999999990.00000')) || '|' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRLO, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' QtNutr=' || TRIM(TO_CHAR(ROUND(:NEW.QTCALCNUTRLO, 5), '9999999990.00000'));
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('RECEFILI', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

